import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataKubernetesIngressConfig extends cdktf.TerraformMetaArguments {
    /**
     * metadata block.
     *
     * @stability stable
     */
    readonly metadata: DataKubernetesIngressMetadata[];
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressSpecBackend extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    get servicePort(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressSpecRuleHttpPathBackend extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    get servicePort(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressSpecRuleHttpPath extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get backend(): any;
    /**
     * @stability stable
     */
    get path(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressSpecRuleHttp extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get path(): any;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressSpecRule extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get host(): string;
    /**
     * @stability stable
     */
    get http(): any;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressSpecTls extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get hosts(): string[];
    /**
     * @stability stable
     */
    get secretName(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressSpec extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get backend(): any;
    /**
     * @stability stable
     */
    get rule(): any;
    /**
     * @stability stable
     */
    get tls(): any;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressStatusLoadBalancerIngress extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get hostname(): string;
    /**
     * @stability stable
     */
    get ip(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressStatusLoadBalancer extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ingress(): any;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngressStatus extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get loadBalancer(): any;
}
/**
 * @stability stable
 */
export interface DataKubernetesIngressMetadata {
    /**
     * An unstructured key value map stored with the ingress that may be used to store arbitrary metadata.
     *
     * More info: http://kubernetes.io/docs/user-guide/annotations
     *
     * @stability stable
     */
    readonly annotations?: {
        [key: string]: string;
    };
    /**
     * Map of string keys and values that can be used to organize and categorize (scope and select) the ingress.
     *
     * May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
     *
     * @stability stable
     */
    readonly labels?: {
        [key: string]: string;
    };
    /**
     * Name of the ingress, must be unique.
     *
     * Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Namespace defines the space within which name of the ingress must be unique.
     *
     * @stability stable
     */
    readonly namespace?: string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesIngress extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataKubernetesIngressConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    spec(index: string): DataKubernetesIngressSpec;
    /**
     * @stability stable
     */
    status(index: string): DataKubernetesIngressStatus;
    private _metadata;
    /**
     * @stability stable
     */
    get metadata(): DataKubernetesIngressMetadata[];
    /**
     * @stability stable
     */
    set metadata(value: DataKubernetesIngressMetadata[]);
    /**
     * @stability stable
     */
    get metadataInput(): DataKubernetesIngressMetadata[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
