import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataKubernetesServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * metadata block.
     *
     * @stability stable
     */
    readonly metadata: DataKubernetesServiceMetadata[];
}
/**
 * @stability stable
 */
export declare class DataKubernetesServiceSpecPort extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get nodePort(): number;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get targetPort(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesServiceSpec extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get clusterIp(): string;
    /**
     * @stability stable
     */
    get externalIps(): string[];
    /**
     * @stability stable
     */
    get externalName(): string;
    /**
     * @stability stable
     */
    get externalTrafficPolicy(): string;
    /**
     * @stability stable
     */
    get healthCheckNodePort(): number;
    /**
     * @stability stable
     */
    get loadBalancerIp(): string;
    /**
     * @stability stable
     */
    get loadBalancerSourceRanges(): string[];
    /**
     * @stability stable
     */
    get port(): any;
    /**
     * @stability stable
     */
    get publishNotReadyAddresses(): boolean;
    /**
     * @stability stable
     */
    get selector(): any;
    /**
     * @stability stable
     */
    get sessionAffinity(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesServiceStatusLoadBalancerIngress extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get hostname(): string;
    /**
     * @stability stable
     */
    get ip(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesServiceStatusLoadBalancer extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ingress(): any;
}
/**
 * @stability stable
 */
export declare class DataKubernetesServiceStatus extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get loadBalancer(): any;
}
/**
 * @stability stable
 */
export interface DataKubernetesServiceMetadata {
    /**
     * An unstructured key value map stored with the service that may be used to store arbitrary metadata.
     *
     * More info: http://kubernetes.io/docs/user-guide/annotations
     *
     * @stability stable
     */
    readonly annotations?: {
        [key: string]: string;
    };
    /**
     * Map of string keys and values that can be used to organize and categorize (scope and select) the service.
     *
     * May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
     *
     * @stability stable
     */
    readonly labels?: {
        [key: string]: string;
    };
    /**
     * Name of the service, must be unique.
     *
     * Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Namespace defines the space within which name of the service must be unique.
     *
     * @stability stable
     */
    readonly namespace?: string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesService extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataKubernetesServiceConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    spec(index: string): DataKubernetesServiceSpec;
    /**
     * @stability stable
     */
    status(index: string): DataKubernetesServiceStatus;
    private _metadata;
    /**
     * @stability stable
     */
    get metadata(): DataKubernetesServiceMetadata[];
    /**
     * @stability stable
     */
    set metadata(value: DataKubernetesServiceMetadata[]);
    /**
     * @stability stable
     */
    get metadataInput(): DataKubernetesServiceMetadata[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
